﻿using UnityEngine;
using HarmonyLib;
using System.Reflection;
using System.Collections.Generic;
using System.Linq;
using System.Reflection.Emit;

[HarmonyPatch(typeof(Stat_Consumable), nameof(Stat_Consumable.ConsumeWithManipulatorCurve))]
public static class Hunger_Systems_Are_Lazy_Game_Design
{
    static IEnumerable<CodeInstruction> Transpiler(IEnumerable<CodeInstruction> instructions)
    {
        Debug.Log("Firing off Hunger_Systems_Are_Lazy_Game_Design");
        var found_craveNormal = false;
        var start_index = -1;
        var end_index = -1;

        var codes = new List<CodeInstruction>(instructions);
        for (var i = 0; i < codes.Count; i++)
        {
            if (codes[i].opcode == OpCodes.Mul)
            {
                if (found_craveNormal)
                {
                    Debug.Log("END " + i);
                    end_index = i;
                    break;
                }
            }
            else
            {
                //Debug.Log("Start: " + (i + 1));
                start_index = i + 1;

                for (var j = start_index; j < codes.Count; j++)
                {
                    if (codes[j].opcode == OpCodes.Mul)
                    {
                        Debug.Log("Found multiplier. " + j);
                        found_craveNormal = true;
                        break;
                    }
                }
            }
        }

        if (start_index > -1 && end_index > -1)
        {
            codes[start_index - 1].opcode = OpCodes.Ldc_R4;
            codes[start_index - 1].operand = 1f;
        }
        return codes.AsEnumerable();
    }
}
/*
[HarmonyPatch(typeof(Stat_Consumable), nameof(Stat_Consumable.ConsumeWithManipulatorCurve))]
class Hunger_Systems_Are_Lazy_Game_Design
{
    // Just because you're not craving water right now doesn't make it less effective at hydrating you. That's dumb.
    static bool Prefix(Stat_Consumable __instance, float yield, bool isRaw)
    {
        Debug.Log("Firing off Hunger_Systems_Are_Lazy_Game_Design");
        var raw_manipulator = Traverse.Create(__instance).Field("rawManipulator").GetValue() as YieldManipulator;
        var cooked_manipulator = Traverse.Create(__instance).Field("rawManipulator").GetValue() as YieldManipulator;

        if (yield < 0f)
        {
            __instance.Value += yield;
            __instance.statTarget.Value = __instance.Value;
            return false;
        }

        __instance.Consuming = true;
        __instance.startConsumeValue = __instance.Value;
        Debug.Log("startConsumeValue: " + __instance.startConsumeValue.ToString());
        
        __instance.timer = 0f;
        float craveNormal = isRaw ? raw_manipulator.GetValue(__instance.statTarget.NormalValue) : cooked_manipulator.GetValue(__instance.statTarget.NormalValue);
        Debug.Log("Yield: " + yield.ToString());
        Debug.Log("craveNormal: " + craveNormal.ToString());
        Debug.Log("pre-statTarget: " + __instance.statTarget.Value.ToString());

        __instance.statTarget.Value += yield * craveNormal;

        Debug.Log("post-statTarget: " + __instance.statTarget.Value.ToString());

        return false;
    }
}
*/
/*
[HarmonyPatch(typeof(Stat_Consumable), nameof(Stat_Consumable.ConsumeWithManipulatorCurve))]
class Hunger_Systems_Are_Lazy_Design
{
    // Just because you're not craving water right now doesn't make it less effective at hydrating you. That's dumb.
    static void Postfix(Stat_Consumable __instance, float yield, bool isRaw)
    {
        Debug.Log("Firing off Hunger_Systems_Are_Lazy_Design");
        var raw_manipulator = Traverse.Create(__instance).Field("rawManipulator").GetValue() as YieldManipulator;
        var cooked_manipulator = Traverse.Create(__instance).Field("rawManipulator").GetValue() as YieldManipulator;

        Debug.Log("yield " + yield.ToString());
        
        raw_manipulator.cravePercent = 0f;
        cooked_manipulator.cravePercent = 0f;
        Debug.Log("raw_manipulator.cravePercent post " + raw_manipulator.cravePercent.ToString());
        Debug.Log("raw_manipulator.cravePercent post " + cooked_manipulator.cravePercent.ToString());

        if (yield < 0f)
        {
            Debug.Log("Firing off Hunger_Systems_Are_Lazy_Design yield < 0f");
            __instance.Value += yield;
            __instance.statTarget.Value = __instance.Value;
        }

        Debug.Log("__instance.startConsumeValue " + __instance.startConsumeValue.ToString());
        Debug.Log("__instance.statTarget.Value " + __instance.statTarget.Value.ToString());

        float num = isRaw ? raw_manipulator.GetValue(__instance.statTarget.NormalValue) : cooked_manipulator.GetValue(__instance.statTarget.NormalValue);
        __instance.statTarget.Value += yield * num;

        Debug.Log("raw_manipulator.GetValue(__instance.statTarget.NormalValue " + raw_manipulator.GetValue(__instance.statTarget.NormalValue).ToString() + " | NormalValue: " + __instance.statTarget.NormalValue);
        Debug.Log("raw_manipulator.GetValue(__instance.statTarget.NormalValue " + cooked_manipulator.GetValue(__instance.statTarget.NormalValue).ToString() + " | NormalValue: " + __instance.statTarget.NormalValue);

        Debug.Log("raw final yield: " + raw_manipulator.finalYield.ToString());
        Debug.Log("cooked final yield: " + cooked_manipulator.finalYield.ToString());
    }
}
*/

public class StopTheCravings : Mod
{
    private Harmony harmony;
    private string harmony_id = "Stop The Cravings";

    public void Start()
    {
        Debug.Log("Just because you're not craving water right now doesn't make it less effective at hydrating you. That's dumb.");
        harmony = new Harmony(harmony_id);
        harmony.PatchAll(Assembly.GetExecutingAssembly());
    }

    public void OnModUnload()
    {
        harmony.UnpatchAll(harmony_id);
        Debug.Log("Your magical stomach has returned.");
    }
}